<?php
require_once("config.php");
require_once("comandos.php");

$stats_url = $_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];
$stats_url = "http://".dirname($stats_url)."/stats.php?c=";

$con = fsockopen($server,6667,$errno,$errstr,5);
if (!$con) {
	echo "Erro ao conectar em ".$server."\n<br>";
 	echo "Nmero do erro: $errno\n<br>";
	echo "Mensagem: $errstr\n<br>";
	flush();
}	

$time["start"] = time();
$time["inc"] = time();

addtimer("checkstats","5");
if ($anuncio) { addtimer("anunciar",$anuncio); }
if ($backup["auto"]) { addtimer("backup",$backup["auto"]); }

scmd("USER $identd 8 *: :$name");
scmd("NICK $botnick");
while (!feof($con)) {
	$buffer = fgets($con,513);
	$line = explode(" ",$buffer);
	$nick = explode("!",substr($line[0],1)); $nick = $nick[0];
	if (isset($_POST["echo"])) { echo "$buffer<br>"; }
	if ($line[1] == "PRIVMSG") {
	    if (preg_match("/\001ACTION(.*)\001/",$buffer)) {
	        if (substr($line[2],0,1) == "#") { misc_count("actions",trim($line[2]),$nick); }
		}
		else { ontext(); }
	}
	elseif ($line[0] == "PING") {
                scmd('PONG' + ' ' + $line[1]);
 		scmd("JOIN $channels");
	 }
	elseif ($line[1] == "KICK") {
	    $channel = strtolower($line[2]);
	    $knick = $line[3];
	    $motivo = substr(trim($line[4]),1);
		unset($nicks[$channel][strtolower($knick)]);
		if (strtolower($line[3]) == strtolower($botnick)) { scmd("JOIN $line[2]"); }
		else { misc_count("kicked",$channel,$knick); }
		misc_count("kicks",$channel,$nick);
	}
	elseif ($line[1] == "JOIN") {
		$channel = strtolower(substr(trim($line[2]),1));
		if ($nick != $botnick) {
			$nicks[$channel][strtolower($nick)] = $nick;
			misc_count("joins",$channel,$nick);
		}
		else { $nicks[$channel] = ""; }
	}
	elseif ($line[1] == "PART") {
		$channel = strtolower(trim($line[2]));
		if ($nick == $botnick) { unset($nicks[$channel]); }
		else { unset($nicks[$channel][strtolower($nick)]); }
	}
	elseif ($line[1] == "NICK") {
		$newnick = trim(substr($line[2],1));
		$split = explode(",",$channels);
		foreach ($split as $channel) {
		    if (!isset($nicks[$channel][strtolower($nick)])) { continue; }
			unset($nicks[$channel][strtolower($nick)]);
			$nicks[$channel][strtolower($newnick)] = $newnick;
			misc_count("changenick",$channel,$nick);
		}
	}
	elseif ($line[1] == "QUIT") {
		$split = explode(",",$channels);
		foreach ($split as $channel) {
		    if (!isset($nicks[$channel][strtolower($nick)])) { continue; }
			unset($nicks[$channel][strtolower($nick)]);
			misc_count("quits",$channel,$nick);
		}
	}
	elseif ($line[1] == "353") {
	    $channel = strtolower($line[4]);
	    $nicklist = substr(emdiante($buffer,6," "),1);
		$nicklist = str_replace(array("@","+",$botnick),"",$nicklist);
		$split = explode(" ",$nicklist);
		foreach ($split as $temp) {
			if (strlen(trim($temp)) < 1) { continue; }
			$nicks[$channel][strtolower($temp)] = $temp;
		}
	}
	elseif (strtolower($nick) == "nickserv") {
		if (preg_match("/voce esta reconhecido/",$buffer) || preg_match("/password accepted/",strtolower($buffer))) { scmd("JOIN $channels"); }
		if (preg_match("/nickserv identify/",strtolower($buffer))) { scmd("NICKSERV IDENTIFY $pass"); }
	}
	elseif ($line[1] == "376") {
		scmd("NICKSERV IDENTIFY $pass");
		sleep(2);
		scmd("JOIN $channels");
	}
	timerscheck();
}
//funcoes diversas
function scmd ($cmd) {
	global $con;
 	fputs($con,$cmd."\n");
}
function parsenum ($number) {
	return str_repeat("0",8-strlen($number)).$number;
}
function duration ($time,$mode) {
	if ($mode == 1) {
		$d = gmdate("z\d H\h i\m",$time);
		$d = explode(" ",$d);
		if ($d[0] > 0) { $d = "$d[0] $d[1]"; } else { $d = "$d[1] $d[2]"; }
		return $d;
	}
	if ($mode == 2) {
  		$days = floor($time / 86400);
  		$hours = floor(($time % 86400) / 3600);
  		$mins = floor(($time % 3600) / 60);
		$d = "";
        if ($days > 0) { $d .= $days." dia"; if ($days > 1) {$d .= "s"; } if ($hours > 0 || $mins > 0) { $d .= ", "; } }
		if ($hours > 0) { $d .= $hours." hora"; if ($hours > 1) { $d .= "s"; } if ($mins > 0) { $d .= ", "; } }
        if ($mins > 0) { $d .= $mins." minuto"; if ($mins > 1) { $d .= "s"; } }
        if ($d) { $d = trim($d); } else { $d = "menos de 1 minuto"; }
		return $d;
	}
}
function emdiante ($texto,$numero,$caractere) {
	$split = explode($caractere,$texto);
	$line = "";
	for ($x = $numero - 1; $x < count($split); $x++) { $line .= $split[$x]." "; }
	return trim($line);
}
function anunciar () {
	global $channels, $stats_url;
	$split = explode(",",$channels);
	foreach ($split as $temp) {
		scmd("PRIVMSG $temp :Veja as estatsticas do canal, estatsticas do bot, quem mais fala, quem mais fica online no canal e o que os usurios esto fazendo em: \00304\002$stats_url".substr($temp,1));
		mostra_cmds($temp,$temp,1);
		sleep(1);
	}
}
function addtimer ($comando,$tempo) {
	global $timers;
	$timers[count($timers)] = array($comando,$tempo,time());
}
function timerscheck () {
	global $timers;
	$x = 0;
	foreach ($timers as $temp) {
		list($comando,$tempo,$executar) = $temp;
		if ((time() - $executar) >= ($tempo * 60)) {
			$comando();
			$timers[$x] = array($comando,$tempo,time());
		}
		$x++;
	}
}
function addcmd ($comando,$onde,$funcao) {
	global $cmds;
	$cmds[count($cmds)] = array($comando,$onde,$funcao);	
}
function floodcheck () {
	global $flood;
	$_flood = 0;
	
	if (!isset($flood["time"])) { $flood["time"] = time(); }
	if (!isset($flood["lines"])) { $flood["lines"] = 0; }
	
	if ((time() - $flood["time"]) >= $flood["intime"]) { $flood["lines"] = 0; }
	if ($flood["lines"] >= $flood["maxcmd"]) { $_flood = 1; }
	else { $flood["lines"] ++; $flood["time"] = time(); }
	
	return $_flood;
}
#eventos
function ontext () {
	global $line, $nick, $cmds, $flood;
	$text = "";
	for ($x = 3; $x < count($line); $x++) { $text .= $line[$x]." "; }
	$text = substr(trim($text),1);
	$split = explode(" ",$text);
	$cmd = strtolower($split[0]);
	if (substr($line[2],0,1) == "#") {
		//texto no canal
		$channel = strtolower($line[2]);
		textcheck($channel,$nick,$text);
		foreach ($cmds as $temp) {
			list($comando,$onde,$str) = $temp;
			if ($comando == $cmd && ($onde == "#" || $onde == $channel) && !floodcheck()) { eval("\$str = $str;"); break; }
		}
	}
	else {
		//texto no PVT
		foreach ($cmds as $temp) {
			list($comando,$onde,$str) = $temp;
			if ($comando == $cmd && $onde == "?" && !floodcheck()) { eval("\$str = $str;"); break; }
		}
	}
}
#checkstats
function checkstats () {
	global $nicks, $channels, $time;
	$timeinc = time() - $time["inc"];
	$time["inc"] = time();
 	$link = db_connect();
	//uptimers
	$split = explode(",",$channels);
	foreach ($split as $channel) {
		if (!isset($channel)) { continue; }
		//chanstats
		$tabela = "chanstats";
		$query = mysql_fetch_array(mysql_query("SELECT * FROM $tabela WHERE canal='$channel'",$link));
		if (isset($query["canal"])) { $query = mysql_query("UPDATE $tabela SET monitorando='".($query["monitorando"] + $timeinc)."' WHERE canal='$channel'",$link); }
		else { $query = mysql_query("INSERT INTO $tabela (canal,monitorando) VALUES ('$channel','$timeinc')",$link); }
		//uptimers count
		$tabela = "stats";
		foreach ($nicks[$channel] as $name => $value) {
			if (!isset($value) || strlen(trim($value)) < 1) { continue; }
			$user = addslashes($value);
			$query = mysql_query("SELECT * FROM $tabela WHERE nick='$user' AND canal='$channel'",$link);
			$query = mysql_fetch_array($query);
			$ctime = time();
			if (isset($query["nick"])) {
				$tempo = parsenum($query["tempo"] + $timeinc);
				mysql_query("UPDATE $tabela SET tempo='$tempo', seen='$ctime' WHERE nick='$user' AND canal='$channel'",$link);
			}
			else {
				$tempo = parsenum($timeinc);
				mysql_query("INSERT INTO $tabela (nick,tempo,canal,seen) VALUES ('$user','$tempo','$channel','$ctime')",$link);
			}
		}
	}
	//record uptime check
	$tabela = "settings";
	$current = time() - $time["start"];
	$query = mysql_fetch_array(mysql_query("SELECT * from $tabela WHERE name='rec_uptime'",$link));
	if (isset($query["name"])) {
	    if ($current > $query["value"]) { $query = mysql_query("UPDATE $tabela SET value='$current' where name='rec_uptime'",$link); }
	}
	else { $query = mysql_query("INSERT INTO $tabela (name,value) VALUES ('rec_uptime','$current')",$link); }
	//count uptime
	$query = mysql_query("SELECT * FROM $tabela WHERE name='count_uptime'",$link);
	$query = mysql_fetch_array($query);
	if (isset($query["name"])) {
		$uptime = $timeinc + $query["value"];
		$query = mysql_query("UPDATE $tabela SET value='$uptime' WHERE name='count_uptime'",$link);
	}
	else { $query = mysql_query("INSERT INTO $tabela (name,value) VALUES ('count_uptime','$timeinc')",$link); }
	mysql_close($link);
}
#kick + joins count
function misc_count ($where,$channel,$user,$acao = "") {
	$link = db_connect();
	$tabela = "stats";
	$user = addslashes($user);
	if ($where != "part") {
		$query = mysql_query("SELECT * FROM $tabela WHERE nick='$user' AND canal='$channel'",$link);
		$query = mysql_fetch_array($query);
		if (isset($query["nick"])) {
			$count = parsenum($query[$where] + 1);
			$query = mysql_query("UPDATE $tabela SET $where='$count', seen='".time()."' WHERE nick='$user' AND canal='$channel'",$link);
		}
		else { $query = mysql_query("INSERT INTO $tabela (nick,canal,$where,seen) VALUES ('$user','$channel','00000001','".time()."')",$link); }
	}
	//join count
	if ($where == "joins" || $where == "kicks" || $where == "quits" || $where == "actions") {
		$tabela = "chanstats";
		$query = mysql_query("SELECT * FROM $tabela WHERE canal='$channel'",$link);
		$query = mysql_fetch_array($query);
		if ($query["canal"]) { $query = mysql_query("UPDATE $tabela SET $where='".($query[$where] + 1)."' WHERE canal='$channel'",$link); }
	}
	mysql_close($link);
}
#text
function textcheck ($channel,$user,$text) {
	$link = db_connect();
	//lines user count
	$tabela = "stats";
	$user = addslashes($user);
	$query = mysql_query("SELECT * FROM $tabela WHERE nick='$user' AND canal='$channel'",$link);
	$query = mysql_fetch_array($query);
	if ($query["nick"] != "") {
		$linhas = parsenum($query["linhas"] + 1);
		mysql_query("UPDATE $tabela SET linhas='$linhas', seen='".time()."' WHERE nick='$user' AND canal='$channel'",$link);
	}
	else { mysql_query("INSERT INTO $tabela (nick,canal,linhas,seen) VALUES ('$user','$channel','00000001','".time()."')",$link); }
	//lines channel count
	$tabela = "chanstats";
	$query = mysql_query("SELECT * FROM $tabela WHERE canal='$channel'",$link);
	$query = mysql_fetch_array($query);
	if ($query["canal"] != "") { $query = mysql_query("UPDATE $tabela SET linhas='".($query["linhas"] + 1)."' WHERE canal='$channel'",$link); }
	else { $query = mysql_query("INSERT INTO $tabela (canal,linhas) VALUES ('$channel','1')",$link); }
	//close
	mysql_close($link);
}
function backup () {
	$host = $_SERVER['SERVER_NAME'];
	$fp = fsockopen($host,80,$err1,$err2,5);
	if (!$fp) { return; }
	fwrite($fp,"GET ".dirname($_SERVER['SCRIPT_NAME'])."/backup.php HTTP/1.1\n");
	fwrite($fp,"Host: $host\n");
	fwrite($fp,"Connection: Close\n");
	fwrite($fp,"\n\n");
	$buffer = "";
	while (!feof($fp)) { $buffer .= fread($fp,4096); }
	fclose($fp);
}
?>
